#include <iostream>
#include <set>
#include "Structures.h"
#include "AneuMeshLoader.h"
#include <memory>

int main() 
{
    MeshLoader* loader = new AneuMeshLoader;
    std::shared_ptr<MeshLoader> smart_loader(loader);
    smart_loader->loadMesh("cube.aneu");
    const auto& nodeSTL = smart_loader->getNodeSTL();
    const auto& finiteSTL = smart_loader->getFiniteSTL();
    const auto& boundarySTL = smart_loader->getBoundarySTL();

    auto elementById = smart_loader->findFiniteElementById(0, 0, 0);
    auto elementByEdge = smart_loader->findFiniteElementByEdge(1, 0);

    auto FEByType = smart_loader->getFiniteElementByMaterial(1);
    auto nodesByBoundary = smart_loader->getNodeSTLByBoundaryId(3);
    auto BFEByBoundary = smart_loader->getBoundaryFiniteElementSTLByBoundaryId(1);
    auto neighbours = smart_loader->getNeighbourSTL();

    smart_loader->insertNodesInCenter();

    return 0;
}
